Subject: bonding and IPv6 "doesn't work"?

From: Tomasz Chmielewski <[email-masked]>
Date: Tue, 12 Jul 2011 18:05:41 +0200

I'm trying to make bonding work with IPv6, using 2.6.39.3 kernel.

Unfortunately, it doesn't seem to work without some rather unintuitive 
workarounds.

I make a bond0 of two interfaces, eth0 and eth1.

As soon as I assign them a IPv6 address, I can see the following message 
in dmesg:

bond0: IPv6 duplicate address 2a01:4f8:120:14c4::1247 detected!

I'm not able to reach any host in the internet:

# assign an IP address
ip -6 addr add 2a01:4f8:120:14c4::1247/64 dev bond0
ip -6 route add 2a01:4f8:120:14c4::15 dev bond0
ip -6 route add default via 2a01:4f8:120:14c4::15

# ping a host in the internet
ping6 -c 1 kernel.org
PING kernel.org(pub1.kernel.org) 56 data bytes

--- kernel.org ping statistics ---
1 packets transmitted, 0 received, 100% packet loss, time 0ms

However if I start bonding with just one interface, add IPv6 address to 
it, then use ifenslave to add a second interface, I'm able to reach the 
hosts in the internet.

# restart network
/etc/init.d/network restart

# remove eth1 from bonding
ifenslave -d bond0 eth1

# assign an IP address
ip -6 addr add 2a01:4f8:120:14c4::1247/64 dev bond0
ip -6 route add 2a01:4f8:120:14c4::15 dev bond0
ip -6 route add default via 2a01:4f8:120:14c4::15

# add eth1 to bonding
ifenslave bond0 eth1

# ping a host in the internet
ping6 -c 1 kernel.org
PING kernel.org(pub4.kernel.org) 56 data bytes
64 bytes from pub4.kernel.org: icmp_seq=0 ttl=49 time=61.6 ms

--- kernel.org ping statistics ---
1 packets transmitted, 1 received, 0% packet loss, time 0ms
rtt min/avg/max/mdev = 61.645/61.645/61.645/0.000 ms, pipe 2

This is 100% reproducible - is it expected?

I've tried setting these sysctl values, but it didn't help:

net.ipv6.conf.eth0.accept_dad = 0
net.ipv6.conf.eth1.accept_dad = 0

# cat /proc/net/bonding/bond0
Ethernet Channel Bonding Driver: v3.7.0 (June 2, 2010)

Bonding Mode: load balancing (round-robin)
MII Status: up
MII Polling Interval (ms): 100
Up Delay (ms): 0
Down Delay (ms): 0

Slave Interface: eth0
MII Status: up
Speed: 100 Mbps
Duplex: full
Link Failure Count: 0
Permanent HW addr: 72:d2:6e:8e:07:4d
Slave queue ID: 0

Slave Interface: eth1
MII Status: up
Speed: 100 Mbps
Duplex: full
Link Failure Count: 0
Permanent HW addr: 6a:f2:e9:64:01:76
Slave queue ID: 0

-- 
Tomasz Chmielewski
http://wpkg.org